#ifndef EPUCK_REALITY_GAP_H
#define EPUCK_REALITY_GAP_H

#include <argos3/core/control_interface/ci_controller.h>

#include <argos3/plugins/robots/e-puck/control_interface/ci_epuck_wheels_actuator.h>
#include <argos3/plugins/robots/e-puck/control_interface/ci_epuck_proximity_sensor.h>
#include <argos3/core/utility/math/vector2.h>
#include <argos3/core/utility/math/rng.h>
#include <argos3/plugins/robots/generic/control_interface/ci_ground_sensor.h>
#include <argos3/plugins/robots/e-puck/control_interface/ci_epuck_rgb_leds_actuator.h>
#include "tcpconnection.h"

using namespace argos;

class CEpuckRealityGap  : public CCI_Controller {
     public: /* argos related */
        CEpuckRealityGap();
        virtual ~CEpuckRealityGap() {};

        virtual void Init(TConfigurationNode& t_node);
        virtual void ControlStep();
        virtual void Reset() {LOG << "reset" << std::endl;};
        virtual void Destroy() {};
        
        void ReadIncomingTCPMessages();
        void TurnRed();
        void TurnLEDsOff();
        UInt8 m_unNbrTurnedRed;
        bool m_bIsRunningRealRobots;
        UInt64 m_unNbCs;
        bool m_bWaitForExperimentToStart;

    protected: 

        bool ObstacleDetected();
        void ObstacleAvoidance();
      
    private: 
        CCI_EPuckWheelsActuator* m_pcWheelAct;
        CCI_EPuckProximitySensor* m_pcProxSens;
        CCI_EPuckRGBLEDsActuator* m_pcRGBLedsAct;
        
        bool m_bOAGoRight;
        CRandom::CRNG *m_pcRNG;

        bool m_bObstacleAvoidanceState;

        bool m_bIsRED;
        UInt8 m_unREDLEDsCpt;

        bool m_bChangeDirection;
        bool m_bChangeDirectionRight;
        UInt8 m_unChangeDirectionCpt;
        UInt8 m_unWaitBeforeReturnRed;
        bool m_bCanTurnRed;
        UInt8 m_unWaitBeforeCheckingObstacle;
        UInt32 m_unCScpt;
        
        TCPConnection* m_pcTcpConnection;
        std::string m_sHost;
        bool m_bCanStart;
        bool m_bIsExperimentFinished;
};
#endif
