#include "tcpconnection.h"


/****************************************/
/****************************************/

TCPConnection::TCPConnection(std::string host, int port) {
    m_sServerHost = host;
    m_unPort = port;
}

void TCPConnection::Start() {
    
    m_pcTCPSocket = new CTCPSocket();

    m_pcTCPSocket->Connect(m_sServerHost, m_unPort);
    
    std::cout << "Connection success" << std::endl;

    pthread_mutex_init(&m_ptmutexLatestMessage, NULL);
    
    if (pthread_create(&m_pthread_s, NULL, &TCPConnection::ThreadEntry, this)) {
        std::cerr << "Failed to create new phtread" << std::endl;
        return;
    }
    std::cout << "Thread created" << std::endl;
}



/****************************************/
/****************************************/

void TCPConnection::Stop() {
    pthread_cancel(m_pthread_s);
    pthread_mutex_destroy(&m_ptmutexLatestMessage);
    m_pcTCPSocket->Disconnect();
}


/****************************************/
/****************************************/
void* TCPConnection::ThreadEntry(void* pc_self) {
	TCPConnection* self = (TCPConnection*) pc_self;
    self->Run();
    return NULL;
}



/****************************************/
/****************************************/
void TCPConnection::Run() {
    std::cout << "Running infinite loop readfromserver" << std::endl;
    while (true) {
        ReadFromServer();
    }
}


/****************************************/
/****************************************/
void TCPConnection::ReadFromServer() {
    CByteArray msgByteArray;
    std::string sMessage;

    //std::cout << "Will call receive byte array on tcp socket" << std::endl;
    if (m_pcTCPSocket->ReceiveByteArray(msgByteArray)) {
        if (msgByteArray.Size() == 0) {
            sMessage = "";
        }
        else {
           // sMessage = "byte array NOT empty";
            msgByteArray >> sMessage;
        }
        
        if (sMessage.size() == 0) {
            sMessage = "";
        } 
        pthread_mutex_lock(&m_ptmutexLatestMessage);
        //std::cout << "updating latest message variable" << std::endl;
        m_sLatestMessage = sMessage;
        pthread_mutex_unlock(&m_ptmutexLatestMessage);
    }
}


/****************************************/
/****************************************/
std::string TCPConnection::GetLatestMessage() {
    pthread_mutex_lock(&m_ptmutexLatestMessage);
    std::string strReturn = m_sLatestMessage;
    m_sLatestMessage = "";
    pthread_mutex_unlock(&m_ptmutexLatestMessage);

    return strReturn;
}


/****************************************/
/****************************************/
void TCPConnection::SendMessage(std::string message) {
    CByteArray byteArray;
    byteArray << message;
    m_pcTCPSocket->SendByteArray(byteArray);
}
