#ifndef TCPCONNECT_H
#define TCPCONNECT_H

#include <argos3/core/utility/networking/tcp_socket.h>
#include <argos3/core/utility/datatypes/byte_array.h>


using namespace argos;

class TCPConnection {

    public:
        TCPConnection() {};
        TCPConnection(std::string host, int port);
        virtual ~TCPConnection() {};

        std::string GetLatestMessage();
        void Start();
        void Stop();

        void SendMessage(std::string message);

    private:

        static void* ThreadEntry(void* pc_self);
        void Run();
        void ReadFromServer();
        

    private:
        std::string m_sServerHost;
        int m_unPort;
        
        CTCPSocket* m_pcTCPSocket;

        pthread_t m_pthread_s;
        pthread_mutex_t m_ptmutexLatestMessage;

        std::string m_sLatestMessage;
};

#endif
